Option Explicit
Const LEDon As Byte = 0
Const LEDoff As Byte = 1
Const LED_VERDE As Byte = 26
Const LED_ROSSO As Byte = 25
Const Pulsante As Byte = 5
Const PortNumber As Byte = 3   
Const TxPin As Byte = 17
Const RxPin As Byte = 16
Const BaudRate As Long = 4800

Public Const OutputBufferSize  As integer = 10
Public Const InputBufferSize  As integer = 80  '134

Public InputBuffer(1 To InputBufferSize) As Byte
Public OuputBuffer(1 To OutputBufferSize) As Byte

'APERTURA DELLA PORTA COM
Public Sub OpenSeriale()
    Call OpenQueue(InputBuffer, InputBufferSize)
    Call OpenQueue(OuputBuffer, OutputBufferSize)
    Call DefineCom3(RxPin, TxPin, bx0000_1000) 'Setta la seriale come inverted, no parity, 8 bits.    
    Call OpenCom(PortNumber, BaudRate, InputBuffer, OuputBuffer)
End Sub
'FUNZIONE PER RICEVERE UN BYTE
Public Sub GetByte( _
    ByRef Value As Byte, _
    ByRef Success As Boolean)

    Success = StatusQueue(InputBuffer)
    If (Success) Then
        Call GetQueue(InputBuffer, Value, 1)
    Else
        Value = 0
    End If

End Sub


'FUNZIONE DI LETTURA GPS
Public Function read_GPS( _
  ByRef latitude as string, _
  ByRef longitude as string, _
  ByRef altitude as string, _
  ByRef dir_lat as byte, _
  ByRef dir_lon as byte) as byte

  Dim Key As Byte
  Dim Success As Boolean	
  Dim sentence(5) as byte 
  Dim start as boolean
  Dim i as byte
  Dim s as byte
  'Legge solo la sentence $GPGGA
  sentence(0) = Asc("$")
  sentence(1) = Asc("G")
  sentence(2) = Asc("P")
  sentence(3) = Asc("G")
  sentence(4) = Asc("G")
  sentence(5) = Asc("A")
  s=0
  i=0
  start = false
  latitude = ""
  longitude = ""
  altitude = ""
  Do   
    Call GetByte(Key, Success) 'Legge un carattere per volta dalla seriale
      if(Success) then
      'Se trova un $ 
      If (Key = 36) and (Not(start)) Then
        start = true	
      End if
      'Se trova uno \r o \n
      If ((Key = 13) or (Key = 10)) and (start)   Then
        start = false	
        read_GPS = 0
        exit function
      End if
      'Se trova un ,
      if(Key = 44) and (start) then
        If (i>15) then
          read_GPS = 0
          exit function
        End if
        i=i+1
      End if	
      if (start) and (Key <> 44)  Then
        if(i=0) then 'check sentence type
          if not(sentence(s)=Key) then
            read_GPS = 0	
            exit function
          End If
          s=s+1
        ElseIf (i=2) then
          latitude = latitude & chr(Key)
        ElseIf (i=3) then
          dir_lat = Key
        ElseIf (i=4) then
          longitude = longitude & chr(Key)
        ElseIf (i=5) then
          dir_lon = Key
        ElseIf (i=6) then
          if (Key = 48) then
            read_GPS = 1
            exit function	
          end if
        ElseIf (i=10) then
          if not(Key=77) then 'M
            read_GPS = 0
            exit function		
          End if
        ElseIf (i=11) then
          altitude = altitude & chr(Key)	
        ElseIf (i=12) then
          If (Key=77) then 'M
            read_GPS = 2
          Else 
            read_GPS = 0
          End if
          exit function
        End if	
      End if			
    End if
  loop
End function 

'----------------------
'MAIN
'----------------------
Public Sub Main()
  Dim res as byte 
  Dim latitude as string
  Dim longitude as string
  Dim altitude as string
  Dim dir_latitude as byte
  Dim dir_longitude as byte

  Call OpenSeriale()
  Do
    Call Delay(0.1)
    Call PutPin(LED_ROSSO, LEDon)
    If (GetPin(Pulsante) = 1) Then
      Call PutPin(LED_VERDE, LEDon)
      res =  read_GPS(latitude,longitude,altitude,dir_latitude,dir_longitude) 
      if (res > 1) then
   			debug.print latitude
			debug.print chr(dir_latitude)
			debug.print longitude
			debug.print chr(dir_longitude)
			debug.print altitude
		ElseIf (res = 1) then
			debug.print "Segnale non buono"
			Call PutPin(LED_ROSSO, LEDoff)
		ElseIf (res = 0) then
			debug.print "Sentence non valida"
			Call PutPin(LED_ROSSO, LEDoff)
   		end if	
     	Call PutPin(LED_VERDE, LEDoff)
	End if
  loop
End Sub
